PROCEDURE GetStdin EXTERNAL "/appl/srvr/lib/amduus_srvr.so" CDECL PERSISTENT:

  DEFINE INPUT-OUTPUT PARAMETER mPtr AS MEMPTR.
  DEFINE RETURN PARAMETER cResult AS CHARACTER.

END. /* PROCEDURE GetStdin */

PROCEDURE PutStdout EXTERNAL "/appl/srvr/lib/amduus_srvr.so" CDECL PERSISTENT:

  DEFINE INPUT PARAMETER cString AS CHARACTER.
  DEFINE RETURN PARAMETER iResult AS SHORT.

END. /* PROCEDURE PutStdout */

PROCEDURE GetClient:

  DEFINE OUTPUT PARAMETER cText AS CHARACTER NO-UNDO.

  DEFINE VARIABLE cResult AS CHARACTER NO-UNDO.
  DEFINE VARIABLE mPtr AS MEMPTR.

  SET-SIZE(mPtr) = 1024.  /* Must match in amduus_srvr.c! */

  RUN GetStdin (INPUT-OUTPUT mPtr, OUTPUT cResult).

  ASSIGN cText = TRIM(GET-STRING(mPtr, 1)).

  SET-SIZE(mPtr) = 0.

END. /* PROCEDURE GetClient */

PROCEDURE PutClient:

  DEFINE INPUT PARAMETER cText AS CHARACTER NO-UNDO.

  DEFINE VARIABLE iResult AS INTEGER NO-UNDO.

  RUN PutStdout (INPUT cText, OUTPUT iResult).

END. /* PROCEDURE PutClient */

